c=======================================================================
cDate of last modification: Wed Jun 28 15:49:47 EDT 1995
CArithmetic check commented out by RQT on Friday June 30 1995.
      subroutine ransi_2(iseed)
c ransr_2: purpose: generate uniform random numbers (slow version)
c double shift register random generator with very long period
c sequential version
c ransr and ransr_2 differ:
c the first is a shift register xor-ed with a linear congruential
c the second xor-es two shift registers
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::c
c Copyright: H.W.J. Bloete and M.P. Nightingale, June 1995  c
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::c
      implicit real*8(a-h,o-z)
c The following parameters for a linear congruential rn generator are from
c Numerical Recipes "An Even Quicker and Dirtier Generator."
c It relies on integer arithmetic that ignores overlows.
c The second set is the same rn generator iterated twice.
      parameter (MULT1=1664525  ,IADD1=1013904223)
      parameter (MULT2=389569705,IADD2=1196435762)
c In k'=mod(k*mult+iadd+2**31,2**32)-2**31
c mod and shift are assumed to be done implicitly by hardware
c the next multiplier is no loner used
c The linear congruential rn generator is used only for initialization of
c the shift registers.

      parameter (TWO=2,TM32=TWO**(-32),HALF=1/TWO)
      dimension rn(1)
      parameter (LEN1=9689,IFD1=471)
      parameter (LEN2= 127,IFD2= 30)
      common/ransrb_2/ ir1(LEN1),ir2(LEN2),inxt1(LEN1),inxt2(LEN2)
      save ipoint1,ipoinf1,k,ipoint2,ipoinf2
      k=3**18+iseed
      l=MULT1*k+IADD1
c check assumption about integer arithmetic
C      call check_arith
C      print *,'ransi_2: overflow handling of integer arithmetic is OK'

c initialize shift registers
      do i=1,LEN1
        k=k*MULT2+IADD2
        l=l*MULT2+IADD2
        ir1(i)=ieor(k,rshift(l,16))
        inxt1(i)=i+1
      enddo
      do i=1,LEN2
        k=k*MULT2+IADD2
        l=l*MULT2+IADD2
        ir2(i)=ieor(k,rshift(l,16))
        inxt2(i)=i+1
      enddo

      inxt1(LEN1)=1
      inxt2(LEN2)=1
      ipoint1=1
      ipoint2=1
      ipoinf1=IFD1+1
      ipoinf2=IFD2+1
      return

      entry ransr_2(rn,n)
c     calculate n random numbers
      do i=1,n
        k1=ieor(ir1(ipoint1),ir1(ipoinf1))
        k2=ieor(ir2(ipoint2),ir2(ipoinf2))
        rn(i)=ieor(k1,k2)*TM32+HALF
        ir1(ipoint1)=k1
        ir2(ipoint2)=k2
        ipoint1=inxt1(ipoint1)
        ipoinf1=inxt1(ipoinf1)
        ipoint2=inxt2(ipoint2)
        ipoinf2=inxt2(ipoinf2)
      enddo
      return
      end
C
